/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: Enum.java,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 13:21:47 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

package com.sun.star.uno;

/** 
 * The Enum class is the base class for all classes generated 
 * as java binding for the IDL type enum.
 * Each java mapped enum class provides static member of this class 
 * which represents the enum values.
 * You cannot create a object of this class or subclass direct, to 
 * avoid enum values with integer values outside the defined range.
 * <p>
 * @version 	$Revision: 1.4 $ $ $Date: 2005/09/08 13:21:47 $
 */
public abstract class Enum {
	private int m_value;

    /**	
	 * Constructs a enum value.
	 * <p>
	 * @param  value   the integer value of this enum value.
     */
	protected Enum(int value) {
		m_value = value;
	}

    /** 
	 * Get the integer value of an enum value.
	 * <p>
	 * @return   the integer value.
     */
	public final int getValue() {
		return m_value;	
	}
}

