#ifndef _COM_SUN_STAR_DRAWING_BEZIERPOINT_HPP_
#define _COM_SUN_STAR_DRAWING_BEZIERPOINT_HPP_

#ifndef _SAL_CONFIG_H_
#include "sal/config.h"
#endif

#ifndef _COM_SUN_STAR_DRAWING_BEZIERPOINT_HDL_
#include "com/sun/star/drawing/BezierPoint.hdl"
#endif

#ifndef _COM_SUN_STAR_AWT_POINT_HPP_
#include "com/sun/star/awt/Point.hpp"
#endif
#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include "com/sun/star/uno/Type.hxx"
#endif
#ifndef _SAL_TYPES_H_
#include "sal/types.h"
#endif
#ifndef _TYPELIB_TYPECLASS_H_
#include "typelib/typeclass.h"
#endif
#ifndef _TYPELIB_TYPEDESCRIPTION_H_
#include "typelib/typedescription.h"
#endif

namespace com { namespace sun { namespace star { namespace drawing {

inline BezierPoint::BezierPoint() SAL_THROW( () )
    : Position()
    , ControlPoint1()
    , ControlPoint2()
{
}

inline BezierPoint::BezierPoint(const ::com::sun::star::awt::Point& Position_, const ::com::sun::star::awt::Point& ControlPoint1_, const ::com::sun::star::awt::Point& ControlPoint2_) SAL_THROW( () )
    : Position(Position_)
    , ControlPoint1(ControlPoint1_)
    , ControlPoint2(ControlPoint2_)
{
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::drawing::BezierPoint const *) {
    //TODO: On certain platforms with weak memory models, the following code can result in some threads observing that the_type points to garbage
    static ::typelib_TypeDescriptionReference * the_type = 0;
    if (the_type == 0) {
        ::typelib_static_type_init(&the_type, typelib_TypeClass_STRUCT, "com.sun.star.drawing.BezierPoint");
    }
    return *reinterpret_cast< ::com::sun::star::uno::Type * >(&the_type);
}

#endif // _COM_SUN_STAR_DRAWING_BEZIERPOINT_HPP_
