#ifndef _COM_SUN_STAR_SCANNER_SCANNEREXCEPTION_HPP_
#define _COM_SUN_STAR_SCANNER_SCANNEREXCEPTION_HPP_

#ifndef _SAL_CONFIG_H_
#include "sal/config.h"
#endif

#ifndef _COM_SUN_STAR_SCANNER_SCANNEREXCEPTION_HDL_
#include "com/sun/star/scanner/ScannerException.hdl"
#endif

#ifndef _COM_SUN_STAR_SCANNER_SCANERROR_HPP_
#include "com/sun/star/scanner/ScanError.hpp"
#endif
#ifndef _COM_SUN_STAR_UNO_EXCEPTION_HPP_
#include "com/sun/star/uno/Exception.hpp"
#endif
#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include "com/sun/star/uno/Type.hxx"
#endif
#ifndef _OSL_MUTEX_HXX_
#include "osl/mutex.hxx"
#endif

namespace com { namespace sun { namespace star { namespace scanner {

inline ScannerException::ScannerException() SAL_THROW( () )
    : ::com::sun::star::uno::Exception()
    , Error(::com::sun::star::scanner::ScanError_ScanErrorNone)
{ }

inline ScannerException::ScannerException(const ::rtl::OUString& Message_, const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& Context_, const ::com::sun::star::scanner::ScanError& Error_) SAL_THROW( () )
    : ::com::sun::star::uno::Exception(Message_, Context_)
    , Error(Error_)
{ }

ScannerException::ScannerException(ScannerException const & the_other): ::com::sun::star::uno::Exception(the_other), Error(the_other.Error) {}

ScannerException::~ScannerException() {}

ScannerException & ScannerException::operator =(ScannerException const & the_other) {
    //TODO: Just like its implicitly-defined counterpart, this function definition is not exception-safe
    ::com::sun::star::uno::Exception::operator =(the_other);
    Error = the_other.Error;
    return *this;
}

} } } }

inline const ::com::sun::star::uno::Type& SAL_CALL getCppuType( const ::com::sun::star::scanner::ScannerException* ) SAL_THROW( () )
{
    static typelib_TypeDescriptionReference * the_type = 0;
    if ( !the_type )
    {
        typelib_static_type_init( &the_type, typelib_TypeClass_EXCEPTION, "com.sun.star.scanner.ScannerException" );
    }
    return * reinterpret_cast< ::com::sun::star::uno::Type * >( &the_type );
}

#endif // _COM_SUN_STAR_SCANNER_SCANNEREXCEPTION_HPP_
