#ifndef _COM_SUN_STAR_SDB_SQLCONTEXT_HPP_
#define _COM_SUN_STAR_SDB_SQLCONTEXT_HPP_

#ifndef _SAL_CONFIG_H_
#include "sal/config.h"
#endif

#ifndef _COM_SUN_STAR_SDB_SQLCONTEXT_HDL_
#include "com/sun/star/sdb/SQLContext.hdl"
#endif

#ifndef _COM_SUN_STAR_SDBC_SQLWARNING_HPP_
#include "com/sun/star/sdbc/SQLWarning.hpp"
#endif
#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include "com/sun/star/uno/Type.hxx"
#endif
#ifndef _OSL_MUTEX_HXX_
#include "osl/mutex.hxx"
#endif
#ifndef _RTL_USTRING_HXX_
#include "rtl/ustring.hxx"
#endif

namespace com { namespace sun { namespace star { namespace sdb {

inline SQLContext::SQLContext() SAL_THROW( () )
    : ::com::sun::star::sdbc::SQLWarning()
    , Details()
{ }

inline SQLContext::SQLContext(const ::rtl::OUString& Message_, const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& Context_, const ::rtl::OUString& SQLState_, const ::sal_Int32& ErrorCode_, const ::com::sun::star::uno::Any& NextException_, const ::rtl::OUString& Details_) SAL_THROW( () )
    : ::com::sun::star::sdbc::SQLWarning(Message_, Context_, SQLState_, ErrorCode_, NextException_)
    , Details(Details_)
{ }

SQLContext::SQLContext(SQLContext const & the_other): ::com::sun::star::sdbc::SQLWarning(the_other), Details(the_other.Details) {}

SQLContext::~SQLContext() {}

SQLContext & SQLContext::operator =(SQLContext const & the_other) {
    //TODO: Just like its implicitly-defined counterpart, this function definition is not exception-safe
    ::com::sun::star::sdbc::SQLWarning::operator =(the_other);
    Details = the_other.Details;
    return *this;
}

} } } }

inline const ::com::sun::star::uno::Type& SAL_CALL getCppuType( const ::com::sun::star::sdb::SQLContext* ) SAL_THROW( () )
{
    static typelib_TypeDescriptionReference * the_type = 0;
    if ( !the_type )
    {
        typelib_static_type_init( &the_type, typelib_TypeClass_EXCEPTION, "com.sun.star.sdb.SQLContext" );
    }
    return * reinterpret_cast< ::com::sun::star::uno::Type * >( &the_type );
}

#endif // _COM_SUN_STAR_SDB_SQLCONTEXT_HPP_
