#ifndef _COM_SUN_STAR_SECURITY_ACCESSCONTROLEXCEPTION_HPP_
#define _COM_SUN_STAR_SECURITY_ACCESSCONTROLEXCEPTION_HPP_

#ifndef _SAL_CONFIG_H_
#include "sal/config.h"
#endif

#ifndef _COM_SUN_STAR_SECURITY_ACCESSCONTROLEXCEPTION_HDL_
#include "com/sun/star/security/AccessControlException.hdl"
#endif

#ifndef _COM_SUN_STAR_UNO_SECURITYEXCEPTION_HPP_
#include "com/sun/star/uno/SecurityException.hpp"
#endif
#ifndef _COM_SUN_STAR_UNO_ANY_HXX_
#include "com/sun/star/uno/Any.hxx"
#endif
#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include "com/sun/star/uno/Type.hxx"
#endif
#ifndef _OSL_MUTEX_HXX_
#include "osl/mutex.hxx"
#endif

namespace com { namespace sun { namespace star { namespace security {

inline AccessControlException::AccessControlException() SAL_THROW( () )
    : ::com::sun::star::uno::SecurityException()
    , LackingPermission()
{ }

inline AccessControlException::AccessControlException(const ::rtl::OUString& Message_, const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& Context_, const ::com::sun::star::uno::Any& LackingPermission_) SAL_THROW( () )
    : ::com::sun::star::uno::SecurityException(Message_, Context_)
    , LackingPermission(LackingPermission_)
{ }

AccessControlException::AccessControlException(AccessControlException const & the_other): ::com::sun::star::uno::SecurityException(the_other), LackingPermission(the_other.LackingPermission) {}

AccessControlException::~AccessControlException() {}

AccessControlException & AccessControlException::operator =(AccessControlException const & the_other) {
    //TODO: Just like its implicitly-defined counterpart, this function definition is not exception-safe
    ::com::sun::star::uno::SecurityException::operator =(the_other);
    LackingPermission = the_other.LackingPermission;
    return *this;
}

} } } }

inline const ::com::sun::star::uno::Type& SAL_CALL getCppuType( const ::com::sun::star::security::AccessControlException* ) SAL_THROW( () )
{
    static typelib_TypeDescriptionReference * the_type = 0;
    if ( !the_type )
    {
        typelib_static_type_init( &the_type, typelib_TypeClass_EXCEPTION, "com.sun.star.security.AccessControlException" );
    }
    return * reinterpret_cast< ::com::sun::star::uno::Type * >( &the_type );
}

#endif // _COM_SUN_STAR_SECURITY_ACCESSCONTROLEXCEPTION_HPP_
