#ifndef _COM_SUN_STAR_SETUP_INSTALLENVIRONMENT_HPP_
#define _COM_SUN_STAR_SETUP_INSTALLENVIRONMENT_HPP_

#ifndef _SAL_CONFIG_H_
#include "sal/config.h"
#endif

#ifndef _COM_SUN_STAR_SETUP_INSTALLENVIRONMENT_HDL_
#include "com/sun/star/setup/InstallEnvironment.hdl"
#endif

#ifndef _COM_SUN_STAR_SETUP_INSTALLTYPE_HPP_
#include "com/sun/star/setup/InstallType.hpp"
#endif
#ifndef _COM_SUN_STAR_SETUP_MODULESTATE_HPP_
#include "com/sun/star/setup/ModuleState.hpp"
#endif
#ifndef _COM_SUN_STAR_SETUP_OSTYPE_HPP_
#include "com/sun/star/setup/OSType.hpp"
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include "com/sun/star/uno/Sequence.hxx"
#endif
#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include "com/sun/star/uno/Type.hxx"
#endif
#ifndef _RTL_USTRING_HXX_
#include "rtl/ustring.hxx"
#endif
#ifndef _SAL_TYPES_H_
#include "sal/types.h"
#endif
#ifndef _TYPELIB_TYPECLASS_H_
#include "typelib/typeclass.h"
#endif
#ifndef _TYPELIB_TYPEDESCRIPTION_H_
#include "typelib/typedescription.h"
#endif

namespace com { namespace sun { namespace star { namespace setup {

inline InstallEnvironment::InstallEnvironment() SAL_THROW( () )
    : eOSType(::com::sun::star::setup::OSType_INVALID)
    , eInstallType(::com::sun::star::setup::InstallType_INVALID)
    , strDestinationPath()
    , nClusterSize(0)
    , nDriveSize(0)
    , seqLanguages()
    , seqSwitchLanguages()
    , seqModuleIDList()
    , strUserName()
    , strUserFirstName()
    , strUserId()
    , strCompanyname()
    , strStreet()
    , strCountry()
    , strZip()
    , strCity()
    , strTitle()
    , strPosition()
    , strPhonePriv()
    , strPhoneCompany()
    , strPhoneFax()
    , strEmail()
    , strState()
    , strFatherName()
    , strApartmentNr()
{
}

inline InstallEnvironment::InstallEnvironment(const ::com::sun::star::setup::OSType& eOSType_, const ::com::sun::star::setup::InstallType& eInstallType_, const ::rtl::OUString& strDestinationPath_, const ::sal_Int32& nClusterSize_, const ::sal_Int32& nDriveSize_, const ::com::sun::star::uno::Sequence< ::sal_Int16 >& seqLanguages_, const ::com::sun::star::uno::Sequence< ::sal_Int16 >& seqSwitchLanguages_, const ::com::sun::star::uno::Sequence< ::com::sun::star::setup::ModuleState >& seqModuleIDList_, const ::rtl::OUString& strUserName_, const ::rtl::OUString& strUserFirstName_, const ::rtl::OUString& strUserId_, const ::rtl::OUString& strCompanyname_, const ::rtl::OUString& strStreet_, const ::rtl::OUString& strCountry_, const ::rtl::OUString& strZip_, const ::rtl::OUString& strCity_, const ::rtl::OUString& strTitle_, const ::rtl::OUString& strPosition_, const ::rtl::OUString& strPhonePriv_, const ::rtl::OUString& strPhoneCompany_, const ::rtl::OUString& strPhoneFax_, const ::rtl::OUString& strEmail_, const ::rtl::OUString& strState_, const ::rtl::OUString& strFatherName_, const ::rtl::OUString& strApartmentNr_) SAL_THROW( () )
    : eOSType(eOSType_)
    , eInstallType(eInstallType_)
    , strDestinationPath(strDestinationPath_)
    , nClusterSize(nClusterSize_)
    , nDriveSize(nDriveSize_)
    , seqLanguages(seqLanguages_)
    , seqSwitchLanguages(seqSwitchLanguages_)
    , seqModuleIDList(seqModuleIDList_)
    , strUserName(strUserName_)
    , strUserFirstName(strUserFirstName_)
    , strUserId(strUserId_)
    , strCompanyname(strCompanyname_)
    , strStreet(strStreet_)
    , strCountry(strCountry_)
    , strZip(strZip_)
    , strCity(strCity_)
    , strTitle(strTitle_)
    , strPosition(strPosition_)
    , strPhonePriv(strPhonePriv_)
    , strPhoneCompany(strPhoneCompany_)
    , strPhoneFax(strPhoneFax_)
    , strEmail(strEmail_)
    , strState(strState_)
    , strFatherName(strFatherName_)
    , strApartmentNr(strApartmentNr_)
{
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::setup::InstallEnvironment const *) {
    //TODO: On certain platforms with weak memory models, the following code can result in some threads observing that the_type points to garbage
    static ::typelib_TypeDescriptionReference * the_type = 0;
    if (the_type == 0) {
        ::typelib_static_type_init(&the_type, typelib_TypeClass_STRUCT, "com.sun.star.setup.InstallEnvironment");
    }
    return *reinterpret_cast< ::com::sun::star::uno::Type * >(&the_type);
}

#endif // _COM_SUN_STAR_SETUP_INSTALLENVIRONMENT_HPP_
