#ifndef _COM_SUN_STAR_SYSTEM_SYSTEMSHELLEXECUTEEXCEPTION_HPP_
#define _COM_SUN_STAR_SYSTEM_SYSTEMSHELLEXECUTEEXCEPTION_HPP_

#ifndef _SAL_CONFIG_H_
#include "sal/config.h"
#endif

#ifndef _COM_SUN_STAR_SYSTEM_SYSTEMSHELLEXECUTEEXCEPTION_HDL_
#include "com/sun/star/system/SystemShellExecuteException.hdl"
#endif

#ifndef _COM_SUN_STAR_UNO_EXCEPTION_HPP_
#include "com/sun/star/uno/Exception.hpp"
#endif
#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include "com/sun/star/uno/Type.hxx"
#endif
#ifndef _OSL_MUTEX_HXX_
#include "osl/mutex.hxx"
#endif
#ifndef _SAL_TYPES_H_
#include "sal/types.h"
#endif

namespace com { namespace sun { namespace star { namespace system {

inline SystemShellExecuteException::SystemShellExecuteException() SAL_THROW( () )
    : ::com::sun::star::uno::Exception()
    , PosixError(0)
{ }

inline SystemShellExecuteException::SystemShellExecuteException(const ::rtl::OUString& Message_, const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& Context_, const ::sal_Int32& PosixError_) SAL_THROW( () )
    : ::com::sun::star::uno::Exception(Message_, Context_)
    , PosixError(PosixError_)
{ }

SystemShellExecuteException::SystemShellExecuteException(SystemShellExecuteException const & the_other): ::com::sun::star::uno::Exception(the_other), PosixError(the_other.PosixError) {}

SystemShellExecuteException::~SystemShellExecuteException() {}

SystemShellExecuteException & SystemShellExecuteException::operator =(SystemShellExecuteException const & the_other) {
    //TODO: Just like its implicitly-defined counterpart, this function definition is not exception-safe
    ::com::sun::star::uno::Exception::operator =(the_other);
    PosixError = the_other.PosixError;
    return *this;
}

} } } }

inline const ::com::sun::star::uno::Type& SAL_CALL getCppuType( const ::com::sun::star::system::SystemShellExecuteException* ) SAL_THROW( () )
{
    static typelib_TypeDescriptionReference * the_type = 0;
    if ( !the_type )
    {
        typelib_static_type_init( &the_type, typelib_TypeClass_EXCEPTION, "com.sun.star.system.SystemShellExecuteException" );
    }
    return * reinterpret_cast< ::com::sun::star::uno::Type * >( &the_type );
}

#endif // _COM_SUN_STAR_SYSTEM_SYSTEMSHELLEXECUTEEXCEPTION_HPP_
