#ifndef _COM_SUN_STAR_TASK_ERRORCODEIOEXCEPTION_HPP_
#define _COM_SUN_STAR_TASK_ERRORCODEIOEXCEPTION_HPP_

#ifndef _SAL_CONFIG_H_
#include "sal/config.h"
#endif

#ifndef _COM_SUN_STAR_TASK_ERRORCODEIOEXCEPTION_HDL_
#include "com/sun/star/task/ErrorCodeIOException.hdl"
#endif

#ifndef _COM_SUN_STAR_IO_IOEXCEPTION_HPP_
#include "com/sun/star/io/IOException.hpp"
#endif
#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include "com/sun/star/uno/Type.hxx"
#endif
#ifndef _OSL_MUTEX_HXX_
#include "osl/mutex.hxx"
#endif
#ifndef _SAL_TYPES_H_
#include "sal/types.h"
#endif

namespace com { namespace sun { namespace star { namespace task {

inline ErrorCodeIOException::ErrorCodeIOException() SAL_THROW( () )
    : ::com::sun::star::io::IOException()
    , ErrCode(0)
{ }

inline ErrorCodeIOException::ErrorCodeIOException(const ::rtl::OUString& Message_, const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& Context_, const ::sal_Int32& ErrCode_) SAL_THROW( () )
    : ::com::sun::star::io::IOException(Message_, Context_)
    , ErrCode(ErrCode_)
{ }

ErrorCodeIOException::ErrorCodeIOException(ErrorCodeIOException const & the_other): ::com::sun::star::io::IOException(the_other), ErrCode(the_other.ErrCode) {}

ErrorCodeIOException::~ErrorCodeIOException() {}

ErrorCodeIOException & ErrorCodeIOException::operator =(ErrorCodeIOException const & the_other) {
    //TODO: Just like its implicitly-defined counterpart, this function definition is not exception-safe
    ::com::sun::star::io::IOException::operator =(the_other);
    ErrCode = the_other.ErrCode;
    return *this;
}

} } } }

inline const ::com::sun::star::uno::Type& SAL_CALL getCppuType( const ::com::sun::star::task::ErrorCodeIOException* ) SAL_THROW( () )
{
    static typelib_TypeDescriptionReference * the_type = 0;
    if ( !the_type )
    {
        typelib_static_type_init( &the_type, typelib_TypeClass_EXCEPTION, "com.sun.star.task.ErrorCodeIOException" );
    }
    return * reinterpret_cast< ::com::sun::star::uno::Type * >( &the_type );
}

#endif // _COM_SUN_STAR_TASK_ERRORCODEIOEXCEPTION_HPP_
