#ifndef _COM_SUN_STAR_UCB_COOKIE_HPP_
#define _COM_SUN_STAR_UCB_COOKIE_HPP_

#ifndef _SAL_CONFIG_H_
#include "sal/config.h"
#endif

#ifndef _COM_SUN_STAR_UCB_COOKIE_HDL_
#include "com/sun/star/ucb/Cookie.hdl"
#endif

#ifndef _COM_SUN_STAR_UTIL_DATETIME_HPP_
#include "com/sun/star/util/DateTime.hpp"
#endif
#ifndef _COM_SUN_STAR_UCB_COOKIEPOLICY_HPP_
#include "com/sun/star/ucb/CookiePolicy.hpp"
#endif
#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include "com/sun/star/uno/Type.hxx"
#endif
#ifndef _RTL_USTRING_HXX_
#include "rtl/ustring.hxx"
#endif
#ifndef _SAL_TYPES_H_
#include "sal/types.h"
#endif
#ifndef _TYPELIB_TYPECLASS_H_
#include "typelib/typeclass.h"
#endif
#ifndef _TYPELIB_TYPEDESCRIPTION_H_
#include "typelib/typedescription.h"
#endif

namespace com { namespace sun { namespace star { namespace ucb {

inline Cookie::Cookie() SAL_THROW( () )
    : Name()
    , Value()
    , Domain()
    , Path()
    , Expires()
    , Secure(false)
    , Policy(::com::sun::star::ucb::CookiePolicy_CONFIRM)
{
}

inline Cookie::Cookie(const ::rtl::OUString& Name_, const ::rtl::OUString& Value_, const ::rtl::OUString& Domain_, const ::rtl::OUString& Path_, const ::com::sun::star::util::DateTime& Expires_, const ::sal_Bool& Secure_, const ::com::sun::star::ucb::CookiePolicy& Policy_) SAL_THROW( () )
    : Name(Name_)
    , Value(Value_)
    , Domain(Domain_)
    , Path(Path_)
    , Expires(Expires_)
    , Secure(Secure_)
    , Policy(Policy_)
{
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::ucb::Cookie const *) {
    //TODO: On certain platforms with weak memory models, the following code can result in some threads observing that the_type points to garbage
    static ::typelib_TypeDescriptionReference * the_type = 0;
    if (the_type == 0) {
        ::typelib_static_type_init(&the_type, typelib_TypeClass_STRUCT, "com.sun.star.ucb.Cookie");
    }
    return *reinterpret_cast< ::com::sun::star::uno::Type * >(&the_type);
}

#endif // _COM_SUN_STAR_UCB_COOKIE_HPP_
