/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: svdio.hxx,v $
 *
 *  $Revision: 1.8 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 18:45:22 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SVDIO_HXX
#define _SVDIO_HXX

//BFS01#ifndef _STREAM_HXX //autogen
//BFS01#include <tools/stream.hxx>
//BFS01#endif

////////////////////////////////////////////////////////////////////////////////////////////////////

//BFS01const char SdrIOMagic [2]={'D','r'};
//BFS01const char SdrIOModlID[2]={'M','d'}; // Model
//BFS01const char SdrIOItPlID[2]={'I','P'}; // ItemPool
//BFS01const char SdrIOLayrID[2]={'L','y'}; // Layer
//#110094#-10
//const char SdrIOLSetID[2]={'L','S'}; // Layerset
//BFS01const char SdrIOPageID[2]={'P','g'}; // Page
//BFS01const char SdrIOMaPgID[2]={'M','P'}; // MasterPage (Stammseite)
//BFS01const char SdrIOMPgDID[2]={'M','D'}; // MasterPageDescriptor
//BFS01const char SdrIOMPDLID[2]={'M','L'}; // MasterPageDescriptorList
//BFS01const char SdrIOHlpLID[2]={'H','l'}; // HelpLine
//BFS01const char SdrIOHLstID[2]={'H','L'}; // HelpLineList
//BFS01const char SdrIODObjID[2]={'O','b'}; // Object
//BFS01const char SdrIOConnID[2]={'C','n'}; // ObjConnection (EdgeObj)
//BFS01const char SdrIOViewID[2]={'V','w'}; // View
//BFS01const char SdrIOPgVwID[2]={'P','V'}; // PageView
//BFS01const char SdrIOEndeID[2]={'X','X'}; // Ende
//BFS01const char SdrIOJoeMagic[4]={'J','o','e','M'}; // Um meine eigenen SubRecords zu erkennen

//BFS01const int nAktSdrFileMajorVersion =  0;

// #84529# increase fileversion to be able to correct gradient rotation for 5.2 and earlierl
//BFS01const int nAktSdrFileMinorVersion = 17; // = 16;

//BFS01const int nAktSdrFileVersion = (nAktSdrFileMajorVersion <<8) + (nAktSdrFileMinorVersion);
//BFS01const int nSdrFileVersion31 = 12; // Fileversion des Office 3.1
//BFS01const int nSdrFileVersion40 = 13; // Fileversion des Office 4.0
//BFS01const int nSdrFileVersion50 = 14; // Fileversion des Office 5.0
//BFS01const int nSdrFileVersion51 = 15; // Fileversion des Office 5.1

// Fileversionen:
//  0= ??-04-1995  Initialversion.
//     24-04-1995  Offizielles Office 3.0 Beta I Shipping
//  1= 25-04-1995  Zus. Flag fuer Layer: Standardlayer (JOE)
//     26-04-1995  AttrObj: Beim Stylesheet-Namen wird zusaetzlich der CharSet gemerkt (SB)
//     28-04-1995  Neu: MasterPageDescriptoren (VisibleLayers f. Masterpages) (JOE)
//  2= 18-05-1995  Drehwinkel und Shearwinkel am Gruppenobjekt (JOE)
//     20-05-1995  EdgeObj nun von TextObj statt von PathObj abgeleitet (JOE)
//  3= 23-05-1995  Textrahmen werden nun durch RectObj dargestellt (JOE)
//  4= 31-05-1995  Weiteres persistentes Flag am Zeichenobjekt bNotVisibleAsMaster (JOE)
//     12-06-1995  Offizielles Office 3.0 Beta II Shipping
//     13-06-1996  bTextToContour raus und durch Item ersetzt (JOE)
//     14-06-1996  SdrItemPool muss nun ohne RefCounts geladen werden (JOE)
//  5= 14-06-1995  SdrOutlinerSetItem als neuer Member im SdrAttrObj (JOE)
//  6= 28-06-1995  Neue Items: pMiscAttr; -> Eckenradius-Member entfaellt am RectObj (JOE)
//  6= 30-06-1995  Neuer Member am SdrGrafObj: aCropRect (JOE)
//  6= 07-07-1995  Neue Items fuer Fontwork am XOutDev (ESO)
//     10-07-1995  Office 3.0 Beta III Shipping an IBM
//  7= 18-07-1995  PolyObj raus, Import am PathObj
//  8= 25-07-1995  GrafObj: zus. Member: aFileName fuer FileLinks
//  9= 02-08-1995  GrafObj: zus. Member: aFilterName fuer FileLinks
//     14-10-1995  Office 3.0 PreRelease fuer Systems Muenchen
//     21-10-1995  Final Office 3.0 Shipping
// 10= 25-10-1995  *pFormTextBoundRect wird gestreamt; Neue Attribute: TextVAdjust, Textabstaende
//     09-11-1995  entgueltiges Format V10 durch erneute Poolumstellung (ExtraPool raus)
// 11= 10-11-1995  - Nicht rueckwaertskompatibel!
//                 - Einfuehrung von Major/MinorVers.
//                 - Aufraeumer: Datensack am Obj f. Konnektoren,...
//                 - bMirrored und aName fuer GrafikObjekt
//                 - DownCompat fuer Grosses, Komplexes und Unbekanntes:
//                   - SdrObject:
//                     - Konnektoren (Flag davor)
//                     - UserDataList (Flag davor)
//                       - UserData
//                   - SdrTextObj:
//                     - OutlinerParaObject (Flag war schon davor)
//                   - SdrPathObj:
//                     - PathPolygon
//                   - SdrEdgeObj:
//                     - EdgeTrack
//                     - Connections haben nun einen eigenen IOHeader
//                   - SdrGrafObj:
//                     - Graphic (Flag davor)
//                     - zus. Flag fuer HasGraphicLink
//                   - SdrOle2Obj:
//                     - Graphic (Flag war schon da)
//                   - SdrModel:
//                     - DocInfo
//                     - DocStatistic (Platz reserviert)
//                     - Misc eingepackt
//                   - SdrPage:
//                     - Misc eingepackt
//                 - Kennung fuer SubRecord meines Model und meiner Page (JoeMagic)
//                 - SvdAttrObj: CharSet fuer StyleSheet entfaellt
//                 - CharSet weg bei SdrModel und SdrAttrObj
//                 - WhichId's weg bei SdrAttrObj und SdrCaptionObj
// 12= 05-12-1995  Neues Item: SdrTextHorzAdjustItem. Textverankerung an Textrahmen und
//                 Grafikobjekten. Beim Import von <V12 werden Grafikobjekte hart attributiert.
//     12-02-1996  UIScale und UIUnit wird vom Model nun rausgeschrieben
//     16-02-1996  Shipping des Office 3.00.2 (SV304a)
//     29-02-1996  Pool V3: 17 neue Items im XOut von KA fuer Bitmapfuellungen
//     13-03-1996  Version fuer CeBit 96
//  ca 15-04-1996  Shipping Version 3.1
//     10-08-1996  Pool Version 4; eigene Items am Verbinder
//     28-08-1996  CeBIT Home
//     21-01-1997  EdgeObj: EdgeInfo und Attribute
// 13= 05-02-1997  Fuer Franz's Dateiformatsumstellungen an der 3D-Engine
// 14= 13-03-1998  Fuer FmFormPage (FormLayer)
// 15= 19-01-1999  Fuer StarDraw-Preview
// 16= 25-08-1999  SdrPage background object

//BFS01class SvStream;

//BFS01class SdrIOHeader
//BFS01{
//BFS01protected:
//BFS01	// 10 Bytes persistent:
//BFS01	char						cMagic[2];
//BFS01	char						cHdrID[2];
//BFS01
//BFS01	// Versionsnummer des Blocks
//BFS01	UINT16						nVersion;
//BFS01
//BFS01	// Gesamtgroesse des Blocks inkl. Header und verschachtelten Bloecken
//BFS01	UINT32						nBlkSize;
//BFS01
//BFS01	// ab hier Verwaltungsinformationen:
//BFS01	SvStream&					rStream;
//BFS01	UINT32						nFilePos;
//BFS01	UINT16						nMode;
//BFS01	BOOL						bOpen;
//BFS01	BOOL						bClosed;
//BFS01	// Header wird nur zum nachschauen verwendet.
//BFS01	BOOL						bLookAhead;
//BFS01
//BFS01	virtual void Write();
//BFS01	virtual void Read();
//BFS01
//BFS01#if 0 // _SOLAR__PRIVATE
//BFS01#ifdef DBG_UTIL
//BFS01	void ImpCheckRecordIntegrity();
//BFS01	void ImpGetRecordName(ByteString& rStr, INT32 nSubRecCount=-1, INT32 nSubRecReadCount=-1) const;
//BFS01	BOOL ImpHasSubRecords() const;
//BFS01#endif
//BFS01#endif // __PRIVATE
//BFS01
//BFS01public:
//BFS01	SdrIOHeader(SvStream& rNewStream, UINT16 nNewMode, const char cID[2]=SdrIOEndeID, BOOL bAutoOpen=TRUE);
//BFS01	virtual ~SdrIOHeader();
//BFS01
//BFS01	BOOL IsMagic() const { return cMagic[0] == SdrIOMagic[0] && cMagic[1] == SdrIOMagic[1];  }
//BFS01	void SetMagic() { cMagic[0] = SdrIOMagic[0]; cMagic[1] = SdrIOMagic[1]; }
//BFS01	BOOL IsEnde() const { return cHdrID[0] == SdrIOEndeID[0] && cHdrID[1] == SdrIOEndeID[1]; }
//BFS01	void SetEnde() { cHdrID[0] = SdrIOEndeID[0]; cHdrID[1] = SdrIOEndeID[1]; nBlkSize = 0; SetMagic(); }
//BFS01	BOOL IsID(const char cID[2]) const { return cHdrID[0] == cID[0] && cHdrID[1] == cID[1]; }
//BFS01	void SetID(const char cID[2]) { cHdrID[0] = cID[0]; cHdrID[1] = cID[1]; SetMagic(); }
//BFS01	UINT16 GetVersion() const { return nVersion; }
//BFS01	UINT16 GetMinorVersion() const { return nVersion | 0xFF; }
//BFS01	UINT16 GetMajorVersion() const { return nVersion >>8; }
//BFS01	UINT32 GetFilePos() const { return nFilePos; }
//BFS01	UINT32 GetBlockSize() const { return nBlkSize; }
//BFS01	void OpenRecord();
//BFS01	void CloseRecord();
//BFS01	UINT32 GetBytesLeft() const;
//BFS01};

//BFS01class SdrIOHeaderLookAhead: public SdrIOHeader
//BFS01{
//BFS01public:
//BFS01	SdrIOHeaderLookAhead(SvStream& rNewStream, BOOL bAutoOpen = TRUE);
//BFS01	void SkipRecord() const { rStream.Seek(nFilePos+nBlkSize); }
//BFS01};

/*
I/O-Format (12+n Bytes)
 4 Inventor
 2 Version
 2 Identifier
 4 Menge der nachfolgenden Daten in Bytes
-------
 2 Layer
16 Allumschliessendes Rechteck
 n>=18 Objektspezifische Daten
*/
//const SdrObjIOHeaderSize=6;

//BFS01class SdrObject;

//BFS01class SdrObjIOHeader: public SdrIOHeader
//BFS01{
//BFS01public:
//BFS01	// ab hier persistente Daten
//BFS01	UINT32						nInventor;
//BFS01	UINT16						nIdentifier;
//BFS01
//BFS01	// ab hier Verwaltungsinformationen
//BFS01	const SdrObject*			pObj;
//BFS01
//BFS01protected:
//BFS01	virtual void Write();
//BFS01	virtual void Read();
//BFS01
//BFS01public:
//BFS01	SdrObjIOHeader(SvStream& rNewStream, UINT16 nNewMode, const SdrObject* pNewObj = NULL, BOOL bAutoOpen = TRUE);
//BFS01
//BFS01	// DTor ueberladen, den in Dtor von SdrIOHeader lebt der SdrObjIOJHeader nicht mehr.
//BFS01	virtual ~SdrObjIOHeader();
//BFS01};

//BFS01class SdrObjIOHeaderLookAhead: public SdrObjIOHeader
//BFS01{
//BFS01public:
//BFS01	SdrObjIOHeaderLookAhead(SvStream& rNewStream, BOOL bAutoOpen = TRUE);
//BFS01	void SkipRecord() const { rStream.Seek(nFilePos+nBlkSize); }
//BFS01};

// Klasse fuer Abwaertskompatibilitaet (Lesen neuer Daten mit altem Code)
// In der Regel reicht es aus, diese Klasse am Anfang des Lese/Schreibfokus
// auf dem Stack mit bAutoOpen=TRUE (default) zu instanziieren. Der Rest
// geschieht von selbst. Will man am Ende des Lesens wissen, ob noch weitere
// Daten im Sub-Record enthalten sind, ruft man GetBytesLeft().
// Den SubRecord schliesst man entweder mit CloseSubRecord() oder man laesst
// ihn vom Destruktor automatisch schliessen.
// Dieses Konzept setzt jedoch eine feste Reihenfolge und Anzahl der SubRecords
// voraus.
//BFS01class SdrDownCompat
//BFS01{
//BFS01protected:
//BFS01	SvStream&					rStream;
//BFS01	UINT32						nSubRecSiz;
//BFS01	UINT32						nSubRecPos;
//BFS01	UINT16						nMode;
//BFS01	BOOL						bOpen;
//BFS01	BOOL						bClosed;
//BFS01
//BFS01	// nur fuer Debug
//BFS01	const char*					pRecId;
//BFS01
//BFS01protected:
//BFS01	virtual void Read();
//BFS01	virtual void Write();
//BFS01
//BFS01public:
//BFS01	// Als Modus muss STREAM_READ oder STREAM_WRITE angegeben werden.
//BFS01	SdrDownCompat(SvStream& rNewStream, UINT16 nNewMode, BOOL bAutoOpen = TRUE);
//BFS01	~SdrDownCompat();
//BFS01
//BFS01#ifdef DBG_UTIL
//BFS01	// fuer etwas aussagekraeftigere Assertions
//BFS01	void SetID(const char* pId) { pRecId=pId; }
//BFS01#endif
//BFS01
//BFS01	// Mit GetBytesLeft() kann man abfragen, ob und wieviele Bytes noch
//BFS01	// im SubRecord stehen. Nur gueltig bei STREAM_READ, sonst 0.
//BFS01	// Nach CloseRecord() liefert diese Methode auch im Modus STREAM_READ 0.
//BFS01	// (Denn dann sind die restlichen Bytes bereits uebersprungen.)
//BFS01	UINT32 GetBytesLeft() const;
//BFS01	BOOL IsOpen() const { return bOpen; }
//BFS01
//BFS01	// Die Pos ist erst gueltig nach Open bzw nach CTor mit bAutoOpen=TRUE.
//BFS01	UINT32 GetSubRecordPos() const { return nSubRecPos; }
//BFS01
//BFS01	// Erst gueltig nach Open bzw. nach CTor mit bAutoOpen=TRUE.
//BFS01	// Beim Modus STREAM_WRITE ist die Size erst nach Close() gueltig.
//BFS01	UINT32 GetSubRecordSize() const { return nSubRecSiz; }
//BFS01	void  OpenSubRecord();
//BFS01	void  CloseSubRecord();
//BFS01};

// Identifier fuer SdrNamedSubRecord bei Inventor==SdrInventor
//BFS01enum {SDRIORECNAME_VIEWPAGEVIEWS   =0x0000,  // alle Pageviews, angezeigte und nicht angezeigte
//BFS01	  SDRIORECNAME_VIEWVISIELEM    =0x0001,  // sichtbare Elemente (Seite, Rand, Gitter, Hilfslinien,...)
//BFS01
//BFS01	  SDRIORECNAME_VIEWSNAP        =0x0010,  // Fangeinstellungen
//BFS01	  SDRIORECNAME_VIEWORTHO       =0x0011,  // Einstellungen fuer Ortho
//BFS01
//BFS01	  SDRIORECNAME_VIEWDRAGMODE    =0x0020,  // Move oder Rotate/Slant/..., bEditMode, RefPoints, FramDragSingles, PlusAlways
//BFS01	  SDRIORECNAME_VIEWMARKEDOBJ   =0x0021,  // (ni) markierte Objekte
//BFS01	  SDRIORECNAME_VIEWMARKEDPNT   =0x0022,  // (ni) markierte Punkte
//BFS01	  SDRIORECNAME_VIEWCROOKCENTER =0x0023,  // Kreismittelpunkt des letzten Crook
//BFS01	  SDRIORECNAME_VIEWMARKEDGLUE  =0x0024,  // (ni) markierte Klebepunkte
//BFS01
//BFS01	  SDRIORECNAME_VIEWDRAGSTRIPES =0x0030,  // Animierte Begrenzungslinien waerend des Draeggens
//BFS01	  SDRIORECNAME_VIEWDRAGHIDEHDL =0x0031,  // Handles waerend des Draeggens verstecken
//BFS01	  SDRIORECNAME_VIEWDRAGEDGES   =0x0032,  // (ni) Einstellungen fuer EdgeDragging
//BFS01	  SDRIORECNAME_VIEWOBJHITMOVES =0x0033,  // Bei MarkedHit Move oder DragMode
//BFS01	  SDRIORECNAME_VIEWMIRRDRAGOBJ =0x0034,  // Obj beim schieben der Spiegelachse zeigen
//BFS01
//BFS01	  SDRIORECNAME_VIEWCROBJECT    =0x0040,  // Aktuelles CreateObj
//BFS01	  SDRIORECNAME_VIEWAKTLAYER    =0x0041,  // Layer fuer Create und Paste (nun in der PaintView)
//BFS01	  SDRIORECNAME_VIEWCRATTRIBUTES=0x0042,  // (ni) Attribute fuer Create
//BFS01	  SDRIORECNAME_VIEWCRSTYLESHEET=0x0043,  // (ni) StyleSheet fuer Create
//BFS01	  SDRIORECNAME_VIEWCRFLAGS     =0x0044,  // Misc Flags fuer Create
//BFS01
//BFS01	  SDRIORECNAME_VIEWTEXTEDIT    =0x0050,  // Div. Einstellungen fuer TextEdit
//BFS01	  SDRIORECNAME_VIEWMACRO       =0x0051,  // Div. Einstellungen fuer Macro
//BFS01
//BFS01	  SDRIORECNAME_VIEWCHARSET     =0x0080,  // Hier merkt sich die SdrView den CharSet und setzt diesem beim Read am Stream
//BFS01
//BFS01	  SDRIORECNAME_PAGVIEW         =0x0100,  // Pageview sichtbar, Seitennummer, Position, Ursprung
//BFS01	  SDRIORECNAME_PAGVLAYER       =0x0101,  // angezeigte, gesperrte und druckbare Layer
//BFS01	  SDRIORECNAME_PAGVHELPLINES   =0x0102,  // Hilfslinien und -punkte
//BFS01	  SDRIORECNAME_PAGVAKTGROUP    =0x0103,  // (ni) aktuelle Gruppe
//BFS01
//BFS01	  SDRIORECNAME_MARK            =0x0200,  // (ni)
//BFS01
//BFS01	  SDRIORECNAME_USERDEFINEDFIRST=0x7000,
//BFS01	  SDRIORECNAME_USERDEFINEDLAST =0x7FFF};

//BFS01class SdrNamedSubRecord: public SdrDownCompat
//BFS01{
//BFS01	UINT32						nInventor;
//BFS01	UINT16						nIdentifier;
//BFS01
//BFS01protected:
//BFS01	virtual void Read();
//BFS01	virtual void Write();
//BFS01
//BFS01public:
//BFS01	SdrNamedSubRecord(SvStream& rNewStream, UINT16 nNewMode,
//BFS01		UINT32 nNewInventor = 0xFFFF, UINT16 nNewIdentifier = 0xFFFF,
//BFS01		BOOL bAutoOpen = TRUE);
//BFS01	UINT32 GetInventor() const { return nInventor; }
//BFS01	UINT16 GetIdentifier() const { return nIdentifier; }
//BFS01};

// Zum Speichern einer View habe ich ein etwas anderes Konzept gewaehlt, da
// sich das Dateiformat hier sicherlich haeufiger und aufwendiger aendert.
// Es werden eine Anzahl von SdrNamedSubRecords geschrieben, wobei jeder
// dieser Records bestimmte Teilinformationen enthaelt, z.B. die Menge der
// sichtbaren Layer einer Page oder den Default-Stylesheet fuer neu zu
// erzeugende Objekte, ... . Diese Konzept hat zwar einen groesseren Overhead
// an Verwaltung und Daten zur Folge, bietet dafuer jedoch eine sehr grosse
// Flexibilitaet im Punkte auf-/abwaertskompatibilitaet. Da die Menge der
// persistenten Daten einer View recht gering ist spielt der Overhead an
// Streamdaten kaum eine Rolle.
// Eine abgeleitete View ueberlaed die Methoden ReadRecord() (lesen eines
// einzelnen Records) und WriteRecords() (schreiben aller Records). Ein Muster
// ist in SdrSnpV.CXX zu finden.

// Folgende Methoden schauen nach, ob sich im Stream an der aktuellen Position
// ein SdrModel bzw. eine SdrView befindet. Hat der Stream einen Fehlerstatus
// oder Eof(), so wird FALSE returniert.
//BFS01BOOL SdrIsModel(SvStream& rIn);
//BFS01BOOL SdrIsView(SvStream& rIn);

#endif //_SVDIO_HXX

/* /////////////////////////////////////////////////////////////////////////////////////////////////

IO-Datenstruktur:

+---------+     +----+               +----+
| SdrData | --->|Modl|-+----->----+->|Ende|--->
+---------+     +----+ |  +----+  |  +----+
                       +<-|View|<-+
                          +----+

+------+         +-------+   +-------+  +--------+                +----+
| Modl |     --->|ModlHdr|-->|ModlDat|->|ItemPool|->+----->----+->|Ende|--->
+------+         +-------+   +-------+  +--------+  |  +----+  |  +----+
                                                    |<-|Layr|<-|
                                                    |  +----+  |
                                                    |  +----+  |
                                                    |<-|LSet|<-|
                                                    |  +----+  |
                                                    |  +----+  |
                                                    +<-|Page|<-+
                                                       +----+

+--------+       +-----------+   +-----------+
|ItemPool|   --->|ItemPoolHdr|-->|SfxItemPool|--->
+--------+       +-----------+   +-----------+

+------+         +-------+   +-------+                +--------+
| Page |     --->|PageHdr|-->|PageDat|->+----->----+->|DObjList|--->
+------+         +-------+   +-------+  |  +----+  |  +--------+
                                        |<-|Layr|<-|
                                        |  +----+  |
                                        |  +----+  |
                                        +<-|LSet|<-+
                                           +----+

+----------+                     +----+
| DObjList | --->+------>-----+->|Ende|--->
+----------+     |  +------+  |  +----+
                 +<-| DObj |<-+
                    +------+

+------+         +-------+   +-------+
| DObj |     --->|DObjHdr|-->|DObjDat|-->+------>-------+--->
+------+         +-------+   +-------+   |  +--------+  |
                                         +->|DObjList|->+
                                            +--------+
+------+         +-------+   +-------+
| Layr |     --->|LayrHdr|-->|LayrDat|--->
+------+         +-------+   +-------+

+------+         +-------+   +-------+
| LSet |     --->|LSetHdr|-->|LSetDat|--->
+------+         +-------+   +-------+

+------+         +-------+   +-------+
| View |     --->|ViewHdr|-->|ViewDat|--->
+------+         +-------+   +-------+

///////////////////////////////////////////////////////////////////////////////////////////////// */

