/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: svdpool.hxx,v $
 *
 *  $Revision: 1.6 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 18:54:19 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SVDPOOL_HXX
#define _SVDPOOL_HXX

#ifndef _XPOOL_HXX
#include <svx/xpool.hxx>
#endif

#ifndef _SVDDEF_HXX
#include <svx/svddef.hxx>
#endif

#ifndef INCLUDED_SVXDLLAPI_H
#include "svx/svxdllapi.h"
#endif

//-/#if SUPD>=366 //|| defined(JOEDEBUG)
//-/#define SDRDEFITEMCACHE
//-/#endif

class XLineAttrSetItem;
class XFillAttrSetItem;
//BFS01class XTextAttrSetItem;
//BFS01class SdrShadowSetItem;
//BFS01class SdrOutlinerSetItem;
//BFS01class SdrMiscSetItem;

////////////////////////////////////////////////////////////////////////////////////////////////////

class SVX_DLLPUBLIC SdrItemPool : public XOutdevItemPool 
{
//BFS04private:
//BFS04	void Ctor();

//BFS04	// Kontstruktion des Pools als MasterPool
//BFS04	SdrItemPool(FASTBOOL bLoadRefCounts = TRUE);

	// Damit meine SetItems mit dem MasterPool konstruiert werden koennen.
	// Der SdrItemPool wird dabei automatisch als Secondary an den
	// uebergebenen MasterPool bzw. an's Ende einer bestehenden Pool-Kette
	// angehaengt.
//BFS04	SdrItemPool(SfxItemPool* pMaster, FASTBOOL bLoadRefCounts = TRUE);
public:
	SdrItemPool(SfxItemPool* pMaster = 0L, sal_Bool bLoadRefCounts = sal_True);
	SdrItemPool(const SdrItemPool& rPool);
	virtual ~SdrItemPool();

	virtual SfxItemPool* Clone() const;
	virtual SfxItemPresentation GetPresentation(const SfxPoolItem& rItem,
		SfxItemPresentation ePresentation,
		SfxMapUnit          ePresentationMetric,
		String&             rText,
        const IntlWrapper * pIntlWrapper
		= 0) const;

//BFS04	static FASTBOOL TakeItemName(USHORT nWhich, String& rItemName);
	static void TakeItemName(sal_uInt16 nWhich, String& rItemName);
	// liefert nur einen String, wenn die DLL mit DBG_UTIL uebersetzt ist
//BFS01	static BOOL TakeWhichName(USHORT nWhich, ByteString& rItemName);
};

////////////////////////////////////////////////////////////////////////////////////////////////////

#endif // _SVDPOOL_HXX
// eof
