/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: tt_enum.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 14:31:45 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef UDM_TYPE_TRAITS_HXX
#define UDM_TYPE_TRAITS_HXX



// USED SERVICES
	// BASE CLASSES
	// COMPONENTS
	// PARAMETERS
#include <cosv/template/tplutil.hxx>

namespace udm
{



template <class XY>
class enum_traits : public type_traits<XY>
{
  private:
    virtual DYN Data *  do_CreateData() const;
    virtual void        do_ConnectOriginal(
                            Data &              o_rData,
                            XY &                io_rOriginal ) const;
    virtual DYN XY *    do_CreateObject() const;
};


/** @resp
*/
class EnumInfo
{
  public:
    typedef ::csv::String                       id;
    typedef std::pair<intt,::csv::String>       value;
    typedef std::vector<value>                  value_vector;

    const value &   operator[](
                        intt                    i_n ) const;
    const value &   operator[](
                        const ::csv::String &   i_str ) const;

    id              name() const;
    int             size() const;

/*
    static const EnumInfo &
                    get_info_(
                        const id &              i_sEnumTypeName );
    static const EnumInfo &
                    create_info_(
                        const id &              i_sEnumTypeName,    /// Must not yet exist.
                        const int *             i_nBegin,           /// Start of vector of i_nCount size.
                        const ::csv::String *   i_sBegin,           /// Start of vector of i_nCount size.
                        unsigned int            i_nCount );
*/
  private:
    typedef std::map< intt, value* >            MapByInt;
    typedef std::map< ::csv::String, value* >   MapByStr;

    // Locals
    static const value &
                    ValueNone_();
    // Data
    value_vector    aValues;        /// @attention must not be empty!
    MapByInt        aMap_byInt;
    MapByStr        aMap_byStr;
    ::csv::String   aName;
    int             nSize;          // Redundant, but faster than aValues.size().
};




}   // namespace udm


#endif


